Attribute VB_Name = "Effex"
' Module of Form Effects.
' Some code by Swift
' Code by Dos is Noted.

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Sub Explosions()

'*******************************************
'Put all this in a Form, Don't use as module.
'This one makes colorful circles
'*******************************************

Dim X As Integer
Dim Y As Integer
Dim Radius As Integer
Dim Limit As Integer
Randomize
ScaleMode = 3
X = Format(Rnd * ScaleWidth, "00")
Y = Format(Rnd * ScaleHeight, "00")
If X > Y Then Limit = Y Else Limit = X
For Radius = 0 To Limit
Circle (X, Y), Radius, RGB(Rnd * 255, Rnd * 255, Rnd * 255)
Next Radius

End Sub

Sub Lasers(FRM As Form)

'Makes many lines pop up, simulating laser effects.

If FRM.WindowState = vbMinimized Then Exit Sub
FRM.BackColor = vbBlack
FRM.ScaleHeight = 100
FRM.ScaleWidth = 100
For X = 0 To 300
DoEvents
X1 = Int(Rnd * 101)
X2 = Int(Rnd * 101)
Y1 = Int(Rnd * 101)
Y2 = Int(Rnd * 101)
colo = Int(Rnd * 15)
FRM.Line (X1, Y1)-(X2, Y2), QBColor(colo)
FRM.Line (X1, Y2)-(X2, Y1), QBColor(colo)
FRM.Line (X2, Y1)-(X1, Y2), QBColor(colo)
FRM.Line (Y1, Y2)-(X1, X2), QBColor(colo)
Next X
End Sub

Sub SlowFadeIn(FRM As Form)

'Slowly Fades Form to Black

Dim intRGBValue
    For intRGBValue = 255 To 0 Step -0.0001
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub SlowFadeOut(FRM As Form)

'Slowly Fades Form to White.

Dim intRGBValue
    For intRGBValue = 0 To 255 Step 0.0001
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub MediumFadeIn(FRM As Form)

'Fades Form to Black, a bit Faster.

Dim intRGBValue
    For intRGBValue = 255 To 0 Step -0.001
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub MediumFadeOut(FRM As Form)

'Fades Form to White, a bit Faster.

Dim intRGBValue
    For intRGBValue = 0 To 255 Step 0.001
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub FastFadeIn(FRM As Form)

'Quickly Fades Form to Black.

Dim intRGBValue
    For intRGBValue = 255 To 0 Step -1
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub FastFadeOut(FRM As Form)

'Quickly Fades Form to White.

Dim intRGBValue
    For intRGBValue = 0 To 255 Step 1
        FRM.BackColor = RGB(intRGBValue, intRGBValue, intRGBValue)
    Next intRGBValue
End Sub

Sub Gradient(TheObject As Object, Redval&, Greenval&, Blueval&, TopToBottom As Boolean)

' Set the forms apperance to FLAT.
' Gradient Me, 0(Red Value), 0(Green Value),
' 255(Blue Value), 1(Top to Bottom; 1 = top
' to bottom, 0 = bottom to top.)

'Makes a fade appeance on the form from one color to black.

Dim Step%, Reps%, FillTop%, FillLeft%, FillRight%, FillBottom%, HColor$
Step = (TheObject.Height / 63)
If TopToBottom = True Then FillTop = 0 Else FillTop = TheObject.Height - Step
FillLeft = 0
FillRight = TheObject.Width
FillBottom = FillTop + Step
For Reps = 1 To 63
TheObject.Line (FillLeft, FillTop)-(FillRight, FillBottom), RGB(Redval, Greenval, Blueval), BF
Redval = Redval - 4
Greenval = Greenval - 4
Blueval = Blueval - 4
If Redval <= 0 Then Redval = 0
If Greenval <= 0 Then Greenval = 0
If Blueval <= 0 Then Blueval = 0
If TopToBottom = True Then FillTop = FillBottom Else FillTop = FillTop - Step
FillBottom = FillTop + Step
Next
End Sub

Sub Explode(FRM As Form)

'makes the form appear in the middle of the screen
'and "explode". Gets larger and larger.

FRM.Width = 0
FRM.Height = 0
FRM.Show
For X = 0 To 8000 Step 250
FRM.Width = X
FRM.Height = X
With FRM
.Left = (Screen.Width - .Width) / 2
.Top = (Screen.Height - .Height) / 2
End With
Next X

End Sub

Sub Explosions()

'*******************************************
'Put all this in a Form, Don't use as module.
'This one makes colorful circles
'*******************************************
Dim X As Integer
Dim Y As Integer
Dim Radius As Integer
Dim Limit As Integer
Randomize
ScaleMode = 3
X = Format(Rnd * ScaleWidth, "00")
Y = Format(Rnd * ScaleHeight, "00")
If X > Y Then Limit = Y Else Limit = X
For Radius = 0 To Limit
Circle (X, Y), Radius, RGB(Rnd * 255, Rnd * 255, Rnd * 255)
Next Radius

End Sub

Public Sub FormExitDown(FRM As Form)
    
'This is From the Dos32 Module.
    
Do
DoEvents
FRM.Top = Trim(Str(Int(FRM.Top) + 300))
Loop Until FRM.Top > 7200

End Sub

Public Sub FormExitLeft(FRM As Form)
    
'This is From the Dos32 Module.
    
Do
DoEvents
FRM.Left = Trim(Str(Int(FRM.Left) - 300))
Loop Until FRM.Left < -FRM.Width

End Sub

Public Sub FormExitRight(FRM As Form)
    
'This is From the Dos32 Module.
    
Do
DoEvents
FRM.Left = Trim(Str(Int(FRM.Left) + 300))
Loop Until FRM.Left > Screen.Width

End Sub

Public Sub FormExitUp(FRM As Form)

'This is From the Dos32 Module.

Do
DoEvents
FRM.Top = Trim(Str(Int(FRM.Top) - 300))
Loop Until FRM.Top < -FRM.Width

End Sub

Public Sub FormDrag(FRM As Form)

'This is From the Dos32 Module.

Call ReleaseCapture
Call SendMessage(FRM.hwnd, WM_SYSCOMMAND, WM_MOVE, 0)

End Sub

Public Sub FormOnTop(FRM As Form)

'This is From the Dos32 Module.
    
Call SetWindowPos(FRM.hwnd, HWND_TOPMOST, 0&, 0&, 0&, 0&, FLAGS)

End Sub

Public Sub FormNotOnTop(FRM As Form)
    
'This is From the Dos32 Module.
    
Call SetWindowPos(FRM.hwnd, HWND_NOTOPMOST, 0&, 0&, 0&, 0&, FLAGS)

End Sub
